// file: bserudiv.cc
// author: Bernt A Oedegaard

#include <cmath>              // mathematical library
#include "fin_algoritms.h"          // define the black scholes price 
#include <vector>

double option_price_european_call_dividends(  double S,               
					      double X,
					      double r,
					      double sigma,           
					      double time_to_maturity,
					      vector<double>& dividend_times,
					      vector<double>& dividend_amounts ) 
// reduce the current stock price by the amount of dividends. 
{  
  for (int i=0;i<dividend_times.size();i++) {
    if (dividend_times[i]<=time_to_maturity){
      S -= dividend_amounts[i] * exp(-r*dividend_times[i]);
    };
  };
  return option_price_call_black_scholes(S,X,r,sigma,time_to_maturity);
};

