// file: black_scholes_delta_put.cc
// author: Bernt A Oedegaard
// The delta of the Black - Scholes formula

#include <cmath>
#include "normdist.h"               

double option_price_delta_put_black_scholes(
					    double S, // spot price
				    double X, // Strike (exercise) price,
				    double r,  // interest rate
				    double sigma,
				    double time) {
    double time_sqrt = sqrt(time);
    double d1 = (log(S/X)+r*time)/(sigma*time_sqrt) + 0.5*sigma*time_sqrt; 
    double delta = -N(-d1);
    return delta;
}
