// file bondopt_call_coupon.cc
// author: Bernt A Oedegaard.

#include <cmath>
#include "normdist.h"
#include "fin_algoritms.h"

double bond_option_price_call_coupon_bond_black_scholes(
   double B, double X, double r, double sigma, double time, 
    vector<double> coupon_times, vector<double> coupon_amounts){
    for (unsigned int i=0;i<coupon_times.size();i++) { // subtract present value of coupons
      if (coupon_times[i]<=time) { // coupon paid befor option expiry
	B -= coupon_amounts[i] * exp(-r*coupon_times[i]);
    };
    };
    return bond_option_price_call_zero_black_scholes(B,X,r,sigma,time);
};
