// file bondopt_call_bs.cc
// author: Bernt A Oedegaard.

#include <cmath>
#include <vector>
#include "normdist.h"

#include "fin_algoritms.h" 

double bond_option_price_put_coupon_bond_black_scholes(
    double B, double X, double r, double sigma, double time, 
    vector<double> coupon_times, vector<double> coupon_amounts){
    for (unsigned int i=0;i<coupon_times.size();i++) {
      if (coupon_times[i]<=time) {
	B -= coupon_amounts[i] * exp(-r*coupon_times[i]);
      };
    };
    return bond_option_price_put_zero_black_scholes(B,X,r,sigma,time);
};
