// file bonds_convexity.cc
// author: Bernt A Oedegaard.
// calculate convexity of a bond.

#include <cmath>
#include <vector>

double bonds_convexity(const vector<double>& cashflow_times,   
		       const vector<double>& cashflow_amounts,
		       const double& y ) 
{
    double C=0;
    for (unsigned i=0;i<cashflow_times.size();i++){
	double t = cashflow_times[i];
	C+= cashflow_amounts[i] * t * t * exp(-y*t);
    };
    return C;
};
