// file bonds_duration.cc
// author: Bernt Arne Odegaard

#include <cmath>
#include <vector>

double bonds_duration(const vector<double>& cashflow_times,
		      const vector<double>& cashflows,
		      const double& r) 
//   calculate the duration of a bond, simple case where the term 
//   structure is flat, interest rate r.
{
    double S=0;
    double D1=0;
    for (unsigned i=0;i<cashflow_times.size();i++){
	S  +=                     cashflows[i] * exp(-r*cashflow_times[i]);
 	D1 += cashflow_times[i] * cashflows[i] * exp(-r*cashflow_times[i]);
    };
    return D1 / S;
};
