// file bonds_price.cc
// author: Bernt A Oedegaard.

#include <cmath>
#include <vector>

double bonds_price(const vector<double>& cashflow_times,
		   const vector<double>& cashflows,
		   const double& r) { 
    // calculate bond price when term structure is flat, 
    double p=0;
    for (unsigned i=0;i<cashflow_times.size();i++) { 
	p += exp(-r*cashflow_times[i])*cashflows[i];
    };
    return p; 
};


