// file bonds_price_both.cc
// author: Bernt A Oedegaard.

#include <cmath>
#include <vector>

double bonds_price(const vector<double>& coupon_times,
		   const vector<double>& coupon_amounts,
		   const vector<double>& principal_times,
		   const vector<double>& principal_amounts, 
		   const double& r) 
  // calculate bond price when term structure is flat, 
  // given both coupon and principals
{ 
    double p = 0; 
    for (unsigned i=0;i<coupon_times.size();i++) { 
	p += exp(-r*coupon_times[i])*coupon_amounts[i];
    };
    for (unsigned i=0;i<principal_times.size();i++) { 
	p += exp(-r*principal_times[i])*principal_amounts[i]; 
    }; 
    return p; 
};
