// file bonds_price.cc
// author: Bernt A Oedegaard.

#include <cmath>
#include <vector>

double bonds_price_discrete(const vector<double>& cashflow_times,
			    const vector<double>& cashflows,
			    const double& r) { 
    // calculate bond price when term structure is flat, 
    double p=0;
    for (unsigned i=0;i<cashflow_times.size();i++) { 
	p +=cashflows[i]/(pow((1+r),cashflow_times[i]));
    };
    return p; 
};
