// file cflow_irr_test_unique.cc 
// author Bernt A Oedegaard

#include <cmath>
#include <vector>

inline int sgn(double& r){ if (r>=0) {return 1;} else {return -1;}; };

bool cash_flow_unique_irr(vector<double>& cflow_times, vector<double>& cflow_amounts) {
    // check whether the cash flow has a unique irr.
    int sign_changes=0;     // first check Descartes rule
    for (unsigned t=1;t<cflow_times.size();++t){
	if (sgn(cflow_amounts[t-1]) !=sgn(cflow_amounts[t])) sign_changes++;
    };
    if (sign_changes==0) return false;  // can not find any irr
    if (sign_changes==1) return true;

    double A = cflow_amounts[0]; // check the aggregate cash flows, due to Norstrom
    sign_changes=0;
    for (unsigned t=1;t<cflow_times.size();++t){
	if (sgn(A) != sgn(A+=cflow_amounts[t])) sign_changes++;
    };
    if (sign_changes<=1) return true;
    return false;
}
