// file cflow_pv.cc
// author: Bernt Arne Oedegaard.
 
#include <cmath>
#include <vector>

double cash_flow_pv( vector<double>& cflow_times, vector<double>& cflow_amounts, double r){
    // calculate present value of cash flow, continous discounting
    double PV=0.0;
    for (unsigned int t=0; t<cflow_times.size();t++) {
	PV += cflow_amounts[t] * exp( -r * cflow_times[t]);
    };
    return PV;
};
