// file cflow_pv_discrete.cc
// author: Bernt Arne Oedegaard.
// calculate the present value of a stream of cash flows using discrete compounding 

#include <cmath>
#include <vector>

double cash_flow_pv_discrete( vector<double>& cflow_times,
			      vector<double>& cflow_amounts,
			      double r){
    double PV=0.0;
    for (unsigned int t=0; t<cflow_times.size();t++) {
	PV += cflow_amounts[t] / pow(1+r,cflow_times[t]);
    };
    return PV;
};
