 // file exotics_lookback_call.cc
// author: Bernt A Oedegaard

#include <cmath>
#include "normdist.h"

double exotics_lookback_european_call(double S,
				   double Smin,
				   double r,
				   double q,
				   double sigma,
				   double time){
    if (r==q) return 0;
    double sigma_sqr=sigma*sigma;
    double time_sqrt = sqrt(time);
    double a1 = (log(S/Smin) + (r-q+sigma_sqr/2.0)*time)/(sigma*time_sqrt);
    double a2 = a1-sigma*time_sqrt;
    double a3 = (log(S/Smin) + (-r+q+sigma_sqr/2.0)*time)/(sigma*time_sqrt);
    double Y1 = 2.0 * (r-q-sigma_sqr/2.0)*log(S/Smin)/sigma_sqr;
    return S * exp(-q*time)*N(a1)
	- S * exp(-q*time)*(sigma_sqr/(2.0*(r-q)))*N(-a1)
	- Smin * exp(-r*time)*(N(a2)-(sigma_sqr/(2*(r-q)))*exp(Y1)*N(-a3));
};
