// file mv_calc.cc
// author: Bernt A Oedegaard
// basic calculations for mean variance analysis

#include "newmat.h"
#include <cmath>

double mv_calculate_mean(const Matrix& e, const Matrix& w){ 
    Matrix tmp = e.t()*w;
    return tmp.element(0,0);
};

double mv_calculate_variance(const Matrix& V, const Matrix& w){ 
    Matrix tmp = w.t()*V*w;
    return tmp.element(0,0);
};

double mv_calculate_st_dev(const Matrix& V, const Matrix& w){ 
    double var = mv_calculate_variance(V,w);
    return sqrt(var);
};
