// file payoff_average.cc 

#include <math.h>
#include <algo.h>
#include <vector.h>

double payoff_arithmetric_average(vector<double>& prices) {
  double sum=accumulate(prices.begin(), prices.end(),0.0);
  double avg = sum/prices.size();
  return max(0.0,avg-prices.back()); 
};

double payoff_geometric_average(vector<double>& prices) {
   double logsum=log(prices[0]);
   for (unsigned i=1;i<prices.size();++i){ logsum+=log(prices[i]); };
   double avg = exp(logsum/prices.size());
   return max(0.0,avg-prices.back()); 
};
