// file simulate_underlying_terminal.cc 

#include <math.h>
#include "random.h"

double simulate_terminal_price(double S,  // current value of underlying
			       double r,  // interest rate
			       double sigma,  // volatitily 
			       double time)  // time to final date
{
   double R = (r - 0.5 * pow(sigma,2) )*time;
   double SD = sigma * sqrt(time);
   return S * exp(R + SD * random_normal());
};
