// file termstru_discfact_cir.cc 
// author: Bernt A Oedegaard

#include <math.h>                     // mathematics library

double term_structure_discount_factor_cir(double t,
				double r,
				double kappa,
				double lambda,
				double theta,
				double sigma)
     // this is the original CIR formulation of their term structure.
{
    double sigma_sqr=pow(sigma,2);
    double gamma = sqrt(pow((kappa+lambda),2)+2.0*sigma_sqr);
    double denum = (gamma+kappa+lambda)*(exp(gamma*t)-1)+2*gamma;
    double p=2*kappa*theta/sigma_sqr;
    double enum1= 2*gamma*exp(0.5*(kappa+lambda+gamma)*t);
    double A = pow((enum1/denum),p);
    double B = (2*(exp(gamma*t)-1))/denum;
    double dfact=A*exp(-B*r);
    return dfact;
};
