// file: cu_spline.cc
// author: Bernt A Oedegaard

#include <math.h>
#include <vector.h>

double term_structure_discount_factor_cubic_spline(double t,
						   double b1,
						   double c1,
						   double d1,
						   const vector<double>& f,
						   const vector<double>& knots)
{ 
    //  calculate the discount factor for the spline functional form. 
    double d = 1.0  
	+ b1*t   
	+ c1*(pow(t,2))   
	+ d1*(pow(t,3)); 
    for (int i=0;i<knots.size();i++) { 
      if (t >= knots[i]) { d += f[i] * (pow((t-knots[i]),3)); } 
      else { break; }; 
    }; 
    return d;   
}; 
