// file esti_cir.cc
// author Bernt Arne Oedegaard

#include <math.h>

double term_structure_discount_factor_estimated_cir( double t,   // time to maturity.
						   double r,	// short interest rate.
						   double phi1,
						   double phi2,
						   double phi3)
{
  double tmp = (phi2*(exp(phi1*t)-1.0)+phi1);
  double A = (phi1*exp(phi2*t))/tmp;
  A = pow(A,phi3);
  double B = (exp(phi1*t)-1.0)/tmp;
  double dfact =  A*exp(-B*r);
  return dfact;
}
