// file termstru_yield_bliss.cc
// author: Bernt A Oedgaard 

#include <math.h>

double term_structure_yield_bliss(double t, double gamma0, double gamma1, double gamma2,
			double lambda1, double lambda2) {
    double r; 
    double t1 = t/lambda1; 
    double t2 = t/lambda2; 
    r = gamma0 
	+ gamma1 * ( (1-exp(-t1)) / t1 ) 
	+ gamma2 * ( ( 1-exp(-t2)) / t2 )  
	+ gamma2 * ( -exp(-t2)); 
    return r;
}; 
