// file nels_sie.cc
// author: Bernt A Oedegaard
// purpose: Calculate the term structure proposed by Nelson and Siegel
// Parsimonious Modeling of Yield Curves, Journal of Business, (1987)

#include <math.h>

double term_structure_yield_nelson_siegel(double t,
					  double beta0, double beta1, double beta2,
					  double lambda ) { 
   if (t==0.0) return beta0;
   double tl = t/lambda; 
   double r = beta0 + (beta1+beta2) * ((1-exp(-tl))/tl) + beta2 * exp(-tl);  
   return r; 
}; 
