// file tst.cc

#include <stream.h>
#include "fin_algoritms.h"
#include "normdist.h"
#include "random.h"

#include "tst_cash_flow.cc"
#include "tst_black_scholes.cc"
#include "tst_binomial.cc"
#include "tst_finite_diff.cc"
#include "tst_simulate.cc"
#include "tst_approximate.cc"
#include "tst_futures.cc"
#include "tst_currency.cc" 
#include "tst_bonds.cc"
#include "tst_alternative_formulas.cc"
#include "tst_exotics.cc"
#include "tst_term_structure.cc"
#include "tst_simulate_general.cc"
#include "tst_bondopt_black_scholes.cc"
#include "tst_bondopt_rend_bart.cc"
#include "tst_bondopt_vasicek.cc"
#include "tst_normal.cc"
#include "tst_random.cc" 

main () { 
    test_cash_flow();
    test_black_scholes();
    test_binomial();
    test_finite_differences(); 
    test_simulate();
    test_approximate();
    test_futures();
    test_currency(); 
    test_bonds();
    test_exotics();
    test_alternative_formulas();
    test_term_structure();
    test_simulate_general();
    test_bondopt_black_scholes();
    test_bondopt_vasicek();
    test_normal();
    test_random();
};


