#include <vector>

void test_black_scholes_price(){
   cout << "Testing Black Scholes price " << endl;
   double spot = 58.507;
   double exercise = 60;
   double r = 0.06; 
   double sigma = 0.35;
   double time_to_maturity=0.25;
   cout << " call price = " 
	<< option_price_call_black_scholes(spot,exercise,r,sigma, time_to_maturity)
	<< endl;
   cout << " put price = " 
	<< option_price_put_black_scholes(spot,exercise,r,sigma, time_to_maturity)
	<< endl;
   cout << " call delta= " 
	<< option_price_delta_call_black_scholes(spot,exercise,r,sigma, time_to_maturity)
	<< endl;
   cout << " put delta = " 
	<< option_price_delta_put_black_scholes(spot,exercise,r,sigma, time_to_maturity)
	<< endl;
};

void test_black_scholes_price_payout(){
   cout << "Testing Black Scholes price with payouts " << endl;
   double spot = 100.0;
   double exercise = 100.0;
   double r = 0.1; 
   double sigma = 0.25;
   double time_to_maturity=1.0;
   double b=0.05;
   cout << "continous payout 5% " << endl;
   cout << " call price: "
	<< option_price_european_call_payout(spot,exercise,r,b,sigma, time_to_maturity)
	<<  endl;
   cout << " put price: "
	<< option_price_european_put_payout(spot,exercise,r,b,sigma, time_to_maturity)
	<< endl; 
   cout << "discrete dividends, european options" << endl;
   vector<double> dividend_times; dividend_times.push_back(0.5);
   vector<double> dividend_amounts; dividend_amounts.push_back(2.0);
   cout << " call price: "
	<< option_price_european_call_dividends(spot,exercise,r,sigma,
						time_to_maturity,
						dividend_times,
						dividend_amounts)
	<<  endl;
   cout << " put price: "
	<< option_price_european_put_dividends(spot,exercise,r,sigma,
					       time_to_maturity,
					       dividend_times,
					       dividend_amounts)
	<<  endl;
   cout << " American call, one dividend, exact solution " << endl;
   double D=2;
   double time_to_dividend=0.5;
   cout << " call price (D=2): "
	<< option_price_american_call_dividend(spot,exercise,r,sigma,
					       time_to_maturity,
					       D,time_to_dividend)
	<<  endl;
   D=10;
   cout << " call price (D=10): "
	<< option_price_american_call_dividend(spot,exercise,r,sigma,
					       time_to_maturity,
					       D,time_to_dividend)
	<<  endl;
};


void test_black_scholes(){
   test_black_scholes_price();
   test_black_scholes_price_payout();
};
