
void test_bondopt_black_scholes(){
    cout << "Testing Black Scholes Bond options " << endl;
    double B=100;
    double X=100;
    double r=0.05;
    double sigma=0.1;
    double time=1;
    cout << " call " 
	 << bond_option_price_call_zero_black_scholes( B,X,r,sigma,time) ;
    cout << " put " 
	 << bond_option_price_put_zero_black_scholes( B,X,r,sigma,time);
    cout << endl;
    vector<double> coupon_times; coupon_times.push_back(0.5);
    vector<double> coupons; coupons.push_back(1);
    cout << " price adjusting for coupon " << endl;
    cout << " call " 
	 << bond_option_price_call_coupon_bond_black_scholes(
	     B,X,r,sigma,time,coupon_times,coupons);
    cout << " put " 
	 << bond_option_price_put_coupon_bond_black_scholes(
	     B,X,r,sigma,time,coupon_times,coupons);    
    cout << endl;
    cout << "Done testing bond options Black Scholes" << endl;
};
