// file tst_bonds.cc

#ifdef _HAVE_TERM_STRUCTURE_CLASS_
#include "termstru_flat.h"
#endif

void test_bonds() {
  cout << "Testing bond algoritms " << endl;
  vector<double> coupon_times; 
  coupon_times.push_back(1); coupon_times.push_back(2); 
  vector<double> coupon_amounts; 
  coupon_amounts.push_back(10); coupon_amounts.push_back(10); 
  vector<double> principal_times; principal_times.push_back(2);
  vector<double> principal_amounts;  principal_amounts.push_back(100); 
  double r = 0.1;
  cout << " price = " 
       <<  bonds_price (coupon_times,coupon_amounts,
			principal_times,principal_amounts,
			r)
       << endl;
  vector <double> cashflow_times;
  cashflow_times.push_back(1);
  cashflow_times.push_back(2);
  vector <double> cashflows;
  cashflows.push_back(10);
  cashflows.push_back(110);
  cout << " price, cashflows case = " 
       <<  bonds_price (cashflow_times, cashflows, r)
       << endl;
  cout << " price, discrete compounding = " 
       <<  bonds_price_discrete (cashflow_times, cashflows, r)
       << endl;
  cout << " duration, simple " 
       << bonds_duration (cashflow_times, cashflows,r)
       << endl;
  double price = bonds_price(cashflow_times, cashflows, 0.11);
  cout << " duration, Macaulay " 
       <<  bonds_duration_macaulay(cashflow_times, cashflows,
				   price)
       << endl;
  cout << " duration, Modified " 
       <<  bonds_duration_modified(cashflow_times, cashflows, price, r)
       << endl;
  double y = bonds_yield_to_maturity(cashflow_times, cashflows, price);
  cout << " yield = " << y << endl;
  cout << " convexity = " 
       <<  bonds_convexity (cashflow_times, cashflows, y)
       << endl;

#ifdef _HAVE_TERM_STRUCTURE_CLASS_
  cout << " using term structure class " << endl;
  
  term_structure_flat d(0.1);
  cout << " price = " 
       <<  bonds_price (cashflow_times, cashflows, d)
       << endl;
  cout << " duration = " 
       <<  bonds_duration(cashflow_times, cashflows, d)
       << endl;
  cout << " duration, Modified " 
       <<  bonds_duration_modified(cashflow_times, cashflows, price,d)
       << endl;
#endif 

  cout << "Done testing bonds " << endl;
};


