// tst_finite_diff.cc

void test_finite_differences(){
    cout << "Testing finite differences " << endl;
    double S = 50.0;
    double X = 50.0;
    double r = 0.1; 
    double sigma = 0.4;
    double time=0.4167;
    int no_S_steps=20;
    int no_t_steps=11;
    cout << " black scholes call price = " 
      << option_price_call_black_scholes(S,X,r,sigma,time)
	<< endl;
    cout << " explicit FD American call price = ";
    cout << option_price_call_american_finite_diff_explicit(S,X,r,sigma,time,no_S_steps,no_t_steps) 
      << endl;
#ifdef _HAVE_NEWMAT_
    cout << " implicit FD American call price = ";
    cout << option_price_call_american_finite_diff_implicit(S,X,r,sigma,time,no_S_steps,no_t_steps) << endl;
#endif
    cout << " black scholes put price = " 
      << option_price_put_black_scholes(S,X,r,sigma,time)
	<< endl;
    cout << " explicit Euro put price = ";
    cout << option_price_put_european_finite_diff_explicit(S,X,r,sigma,time,no_S_steps,no_t_steps) << endl;

#ifdef _HAVE_NEWMAT_
    cout << " implicit Euro put price = ";
    cout << option_price_put_european_finite_diff_implicit(S,X,r,sigma,time,no_S_steps,no_t_steps) << endl;
#endif
    cout << " explicit American put price = ";
    cout << option_price_put_american_finite_diff_explicit(S,X,r,sigma,time,no_S_steps,no_t_steps) << endl;
#ifdef _HAVE_NEWMAT_
    cout << " implicit American put price = ";
    cout << option_price_put_american_finite_diff_implicit(S,X,r,sigma,time,no_S_steps,no_t_steps) << endl;
#endif
    cout << " done finite differences " << endl;
};
