// file tst_simulate_general.cc
// author: Bernt Arne Odegaard

#include "fin_algoritms.h"

void test_simulate_general(){
  cout << "Testing general simulations " << endl;
  double S=100;
  double X=100;
  double r=0.05;
  double time =1;
  double sigma=0.2;
  int no_sims = 10000;
  cout << " Black Scholes call price " 
       << option_price_call_black_scholes(S,X,r,sigma,time) 
       << "   to be compared to " 
       << endl;
  cout << " simulated Black Scholes call " 
       << derivative_price_european_simulated(S,X,r,sigma,time,
					      payoff_european_call,no_sims) 
       << endl; 
  cout << " Black Scholes put price " 
       << option_price_put_black_scholes(S,X,r,sigma,time) 
       << "   to be compared to " 
       << endl;
  cout << " simulated Black Scholes put " 
       << derivative_price_european_simulated(S,X,r,sigma,time,
					      payoff_european_put,no_sims) 
       << endl; 

  no_sims = 500;
  int no_steps = 300;

  cout << " simulated arithmetric average " 
       << " S= " <<  S << " r= " << r << " price="
       << derivative_price_european_simulated(S,r,sigma,time,
					      payoff_arithmetric_average,
					      no_steps,no_sims) 
       << endl; 

  cout << " simulated geometric average " 
       << derivative_price_european_simulated(S,r,sigma,time,
					      payoff_geometric_average,
					      no_steps,no_sims) 
       << endl; 
  
  cout << " simulated geometric average, control variates " 
       << derivative_price_european_simulated_control_variate(S,r,sigma,time,
							      payoff_geometric_average,
							      no_steps,no_sims) 
       << endl; 
  cout << " simulated max  " 
       << derivative_price_european_simulated(S,r,sigma,time,
					      payoff_max,
					      no_steps,no_sims) 
       << endl; 
  cout << " simulated min " 
       << derivative_price_european_simulated(S,r,sigma,time,
					      payoff_min,no_steps,no_sims) 
       << endl; 
};
