// file tst_term_structure.cc

void test_transforms() {
  cout << " testing transformations " << endl;
    double r=0.1;
    double t=1;
    double d=0.9;
    cout << " r= " << r << " t = " << t << " gives disc.fact " 
	 << term_structure_discount_factor_from_yield(r,t) << endl;
    cout << " d= " << d << " t = " << t << " gives yield " 
	 << term_structure_yield_from_discount_factor(d,t) << endl;
    double d1=0.8;
    cout << " implied forward rate, d = " << d << " d1= " << d1 << " t= " << t
	 << " forward = "
	 << term_structure_forward_rate_from_disc_facts(d,d1,t) << endl;
};


void test_cir() {
    cout << " cir dfact (t=1): " 
	 << term_structure_discount_factor_cir(1.0,0.1,0.1,0.1,0.1,0.1)
	 << endl;
}

void test_vasicek() {
    cout << " vasicek dfact (t=1): " 
	 << term_structure_discount_factor_vasicek(1.0,0.05,-0.1,0.1,0.1)
	 << endl;
}

void test_esti_cir() {
    cout << " estimated cir discount_factor (t=1): " 
	 << term_structure_discount_factor_estimated_cir(1.0,0.1,0.1,0.1,1.1)
	 << endl;
};

void test_nelson_siegel(){
    double t=1.0;
    cout << " ns= " << term_structure_yield_nelson_siegel(t,0.1,0.1,0.1,1.0) << endl;
};

void test_bliss(){
    double t=1.0;
    cout << " bliss r(t=1) " 
	 << term_structure_yield_bliss(t,0.1,0.1,0.1,1.0,1.0)
	 << endl;
};

void test_spline(){
    double b=0.1;
    double c=0.1;
    double d=-0.1;
    vector<double> f;
    f.push_back(0.01); f.push_back(0.01);f.push_back(-0.01);
    vector<double> knots;
    knots.push_back(2); knots.push_back(7); knots.push_back(12); 
    double t=1.0;
    cout << "spline disc fact "
	 <<term_structure_discount_factor_cubic_spline(t,b,c,d,f,knots)
	 << endl;
};

void test_interpolated(){
    vector<double> times; 
    times.push_back(0.1); 
    times.push_back(0.5);
    times.push_back(1);
    times.push_back(5);
    times.push_back(10);
    vector<double> yields; 
    yields.push_back(0.1);
    yields.push_back(0.2);
    yields.push_back(0.3);
    yields.push_back(0.4);
    yields.push_back(0.5);
    cout << " testing interpolated " << endl;
    cout << " t=.1 " << term_structure_yield_linearly_interpolated(0.1,times,yields) << endl;
    cout << " t=0.5 " << term_structure_yield_linearly_interpolated(0.5,times,yields) << endl;
    cout << " t=1 " << term_structure_yield_linearly_interpolated(1,times,yields) << endl;
    cout << " t=3 " << term_structure_yield_linearly_interpolated(3,times,yields) << endl;
    cout << " t=5 " << term_structure_yield_linearly_interpolated(5,times,yields) << endl; 
    cout << " t=10 " << term_structure_yield_linearly_interpolated(10,times,yields) << endl;
};

void test_term_structure() 
{
  cout << " testing term structure calculations " << endl;
  test_transforms();
  test_interpolated();
  test_spline();
  test_bliss();
  test_nelson_siegel();
  test_vasicek();
  test_cir();
  test_esti_cir();
  cout << " done test " << endl;
};
